> For the complete documentation index, see [llms.txt](https://docs.mellow.finance/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.mellow.finance/resources/mellow-lrt-depreciated/modules/tvlmodules/managedtvlmodule.md).

# ManagedTvlModule

### Overview

`ManagedTvlModule` contract provides a mechanism to artificially reduce or increase tvl using regular or debt tokens in the vault to reduce possible losses due to slashing events.

### Key Features

* **Parameter Management**: Enables setting of asset parameters used for calculating TVL.
* **TVL Calculation**: Computes the TVL for the vault according to the predefined asset parameters.
* **Access Control**: Ensures only authorized administrators can modify vault parameters.

### Methods

1. **Parameter Management**
   * `setParams(address, Data[])`: Sets asset parameters for a given vault.
     * **vault**: The address of the vault.
     * **data**: An array of `Data` structures containing asset details.
     * **Event**:
       * `ManagedTvlModuleSetParams(address, Data[], uint256)`: Emitted after asset parameters are set for a vault.
         * **vault**: Address of the vault.
         * **data**: An array of `Data` structures.
         * **timestamp**: Timestamp of the parameter update.
2. **TVL Calculation**
   * `tvl(address)`: Computes the total value locked for the vault based on predefined asset parameters.
     * **vault**: The address of the vault.
     * **Returns**: An array of `Data` structures with details about each asset:
       * **token**: Address of the ERC20 token.
       * **underlyingToken**: Address of the base asset.
       * **amount**: The amount of the token held by the vault.
       * **underlyingAmount**: Amount translated to the base asset.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.mellow.finance/resources/mellow-lrt-depreciated/modules/tvlmodules/managedtvlmodule.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
